<?php

namespace DBSchenker\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for schenkerServiceExceptionError StructType
 * Meta information extracted from the WSDL
 * - documentation: Defines the schenker exception error
 * @subpackage Structs
 */
class SchenkerServiceExceptionError extends AbstractStructBase
{
    /**
     * The code
     * Meta information extracted from the WSDL
     * - documentation: Holds exception error code
     * - minOccurs: 0
     * @var string
     */
    public $code;
    /**
     * The message
     * Meta information extracted from the WSDL
     * - documentation: Holds exception error message
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * Constructor method for schenkerServiceExceptionError
     * @uses SchenkerServiceExceptionError::setCode()
     * @uses SchenkerServiceExceptionError::setMessage()
     * @param string $code
     * @param string $message
     */
    public function __construct($code = null, $message = null)
    {
        $this
            ->setCode($code)
            ->setMessage($message);
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \DBSchenker\StructType\SchenkerServiceExceptionError
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \DBSchenker\StructType\SchenkerServiceExceptionError
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
}
